diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.34/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.33/src/sixlowpan/model/sixlowpan-net-device.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/sixlowpan/model/sixlowpan-net-device.cc	2021-07-14 10:31:07.000000000 -0700
@@ -196,7 +196,6 @@
                                             PacketType packetType)
 {
   NS_LOG_FUNCTION (this << incomingPort << packet << protocol << src << dst);
-  NS_LOG_DEBUG ("UID is " << packet->GetUid ());
 
   uint8_t dispatchRawVal = 0;
   SixLowPanDispatch::Dispatch_e dispatchVal;
@@ -349,8 +348,14 @@
           m_dropTrace (DROP_DISALLOWED_COMPRESSION, copyPkt, m_node->GetObject<SixLowPanNetDevice> (), GetIfIndex ());
           return;
         }
-      DecompressLowPanIphc (copyPkt, realSrc, realDst);
-      isPktDecompressed = true;
+      if (DecompressLowPanIphc (copyPkt, realSrc, realDst))
+        {
+          m_dropTrace (DROP_SATETFUL_DECOMPRESSION_PROBLEM, copyPkt, m_node->GetObject<SixLowPanNetDevice> (), GetIfIndex ());
+        }
+      else
+        {
+          isPktDecompressed = true;
+        }
       break;
     default:
       NS_LOG_DEBUG ("Unsupported 6LoWPAN encoding: dropping.");
@@ -568,6 +573,8 @@
 
   SixLowPanMesh meshHdr;
   SixLowPanBc0 bc0Hdr;
+  uint32_t extraHdrSize = 0;
+
   if (useMesh)
     {
       Address source = src;
@@ -591,7 +598,9 @@
       meshHdr.SetFinalDst (destination);
       meshHdr.SetHopsLeft (m_meshUnderHopsLeft);
       destination = m_netDevice->GetBroadcast ();
-      pktSize += meshHdr.GetSerializedSize () + bc0Hdr.GetSerializedSize ();
+      // We are storing sum of mesh and bc0 header sizes. We will need it if packet is fragmented.
+      extraHdrSize = meshHdr.GetSerializedSize () + bc0Hdr.GetSerializedSize ();
+      pktSize +=  extraHdrSize;
     }
 
   if (pktSize < m_compressionThreshold)
@@ -613,7 +622,7 @@
       NS_LOG_LOGIC ("Fragmentation: Packet size " << packet->GetSize () << " - Mtu " << m_netDevice->GetMtu () );
       // fragment
       std::list<Ptr<Packet> > fragmentList;
-      DoFragmentation (packet, origPacketSize, origHdrSize, fragmentList);
+      DoFragmentation (packet, origPacketSize, origHdrSize, extraHdrSize, fragmentList);
       std::list<Ptr<Packet> >::iterator it;
       bool success = true;
       for ( it = fragmentList.begin (); it != fragmentList.end (); it++ )
@@ -711,6 +720,8 @@
   SixLowPanHc1 hc1Header;
   uint32_t size = 0;
 
+  NS_LOG_DEBUG ( "Original packet: " << *packet << " Size " << packet->GetSize () );
+
   if ( packet->PeekHeader (ipHeader) != 0 )
     {
       packet->RemoveHeader (ipHeader);
@@ -922,7 +933,7 @@
 
   packet->AddHeader (ipHeader);
 
-  NS_LOG_DEBUG ( "Rebuilt packet: " << *packet << " Size " << packet->GetSize () );
+  NS_LOG_DEBUG ( "Rebuilt packet:  " << *packet << " Size " << packet->GetSize () );
 }
 
 uint32_t
@@ -934,6 +945,7 @@
   SixLowPanIphc iphcHeader;
   uint32_t size = 0;
 
+  NS_LOG_DEBUG ( "Original packet: " << *packet << " Size " << packet->GetSize () << " src: " << src << " dst: " << dst);
 
   if ( packet->PeekHeader (ipHeader) != 0 )
     {
@@ -1002,7 +1014,6 @@
           iphcHeader.SetNextHeader (nextHeader);
         }
 
-
       // Set the HLIM field
       if (ipHeader.GetHopLimit () == 1)
         {
@@ -1023,44 +1034,101 @@
           iphcHeader.SetHopLimit (ipHeader.GetHopLimit ());
         }
 
-      // \todo Add the check of CID if there is context-based compression
-      // Set the CID field
+      // Set the CID + SAC + DAC fields to their default value
       iphcHeader.SetCid (false);
-
-      // \todo Add the check of SAC if there is context-based compression
-      // Set the SAC field
       iphcHeader.SetSac (false);
+      iphcHeader.SetDac (false);
 
-      uint8_t addressBuf[16];
-      uint8_t unicastAddrCheckerBuf[16];
-      Ipv6Address srcAddr = ipHeader.GetSourceAddress ();
-      srcAddr.GetBytes (addressBuf);
 
       Ipv6Address checker = Ipv6Address ("fe80:0000:0000:0000:0000:00ff:fe00:1");
+      uint8_t unicastAddrCheckerBuf[16];
       checker.GetBytes (unicastAddrCheckerBuf);
+      uint8_t addressBuf[16];
 
-      // \todo Add the check of SAC if there is context-based compression
-      // Set the Source Address
-      iphcHeader.SetSrcAddress (srcAddr);
+      // This is just to limit the scope of some variables.
+      if (true)
+        {
+          Ipv6Address srcAddr = ipHeader.GetSourceAddress ();
+          uint8_t srcContextId;
 
-      Ipv6Address mySrcAddr = Ipv6Address::MakeAutoconfiguredLinkLocalAddress (src);
-      NS_LOG_LOGIC ("Checking source compression: " << mySrcAddr << " - " << srcAddr );
+          // The "::" address is compressed as a fake stateful compression.
+          if (srcAddr == Ipv6Address::GetAny ())
+            {
+              // No context information is needed.
+              iphcHeader.SetSam (SixLowPanIphc::HC_INLINE);
+              iphcHeader.SetSac (true);
+            }
+          // Check if the address can be compressed with stateful compression
+          else if ( FindUnicastCompressionContext (srcAddr, srcContextId) )
+            {
+              // We can do stateful compression.
+              NS_LOG_LOGIC ("Checking stateful source compression: " << srcAddr );
 
-      if ( mySrcAddr == srcAddr )
-        {
-          iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_0);
-        }
-      else if (memcmp (addressBuf, unicastAddrCheckerBuf, 14) == 0)
-        {
-          iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_16);
-        }
-      else if ( srcAddr.IsLinkLocal () )
-        {
-          iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_64);
-        }
-      else
-        {
-          iphcHeader.SetSam (SixLowPanIphc::HC_INLINE);
+              iphcHeader.SetSac (true);
+              if (srcContextId != 0)
+                {
+                  // the default context is zero, no need to explicit it if it's zero
+                  iphcHeader.SetSrcContextId (srcContextId);
+                  iphcHeader.SetCid (true);
+                }
+
+              // Note that a context might include parts of the EUI-64 (i.e., be as long as 128 bits).
+
+              if (Ipv6Address::MakeAutoconfiguredAddress (src, m_contextTable[srcContextId].contextPrefix) == srcAddr)
+                {
+                  iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_0);
+                }
+              else
+                {
+                  Ipv6Address cleanedAddr = CleanPrefix (srcAddr, m_contextTable[srcContextId].contextPrefix);
+                  uint8_t serializedCleanedAddress[16];
+                  cleanedAddr.Serialize (serializedCleanedAddress);
+
+                  if ( serializedCleanedAddress[8] == 0x00 && serializedCleanedAddress[9] == 0x00 &&
+                      serializedCleanedAddress[10] == 0x00 && serializedCleanedAddress[11] == 0xff &&
+                      serializedCleanedAddress[12] == 0xfe && serializedCleanedAddress[13] == 0x00 )
+                    {
+                      iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_16);
+                      iphcHeader.SetSrcInlinePart (serializedCleanedAddress+14, 2);
+                    }
+                  else
+                    {
+                      iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_64);
+                      iphcHeader.SetSrcInlinePart (serializedCleanedAddress+8, 8);
+
+                    }
+                }
+            }
+          else
+            {
+              // We must do stateless compression.
+              NS_LOG_LOGIC ("Checking stateless source compression: " << srcAddr );
+
+              srcAddr.GetBytes (addressBuf);
+
+              uint8_t serializedSrcAddress[16];
+              srcAddr.Serialize (serializedSrcAddress);
+
+              if ( srcAddr == Ipv6Address::MakeAutoconfiguredLinkLocalAddress (src) )
+                {
+                  iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_0);
+                }
+              else if (memcmp (addressBuf, unicastAddrCheckerBuf, 14) == 0)
+                {
+                  iphcHeader.SetSrcInlinePart (serializedSrcAddress+14, 2);
+                  iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_16);
+                }
+              else if ( srcAddr.IsLinkLocal () )
+                {
+                  iphcHeader.SetSrcInlinePart (serializedSrcAddress+8, 8);
+                  iphcHeader.SetSam (SixLowPanIphc::HC_COMPR_64);
+                }
+              else
+                {
+                  iphcHeader.SetSrcInlinePart (serializedSrcAddress, 16);
+                  iphcHeader.SetSam (SixLowPanIphc::HC_INLINE);
+                }
+            }
         }
 
       // Set the M field
@@ -1073,69 +1141,156 @@
           iphcHeader.SetM (false);
         }
 
-      // \todo Add the check of DAC if there is context-based compression
-      // Set the DAC field
-      iphcHeader.SetDac (false);
-
-      Ipv6Address dstAddr = ipHeader.GetDestinationAddress ();
-      dstAddr.GetBytes (addressBuf);
+      // This is just to limit the scope of some variables.
+      if (true)
+        {
+          Ipv6Address dstAddr = ipHeader.GetDestinationAddress ();
+          dstAddr.GetBytes (addressBuf);
 
-      // \todo Add the check of DAC if there is context-based compression
-      // Set the Destination Address
-      iphcHeader.SetDstAddress (dstAddr);
+          NS_LOG_LOGIC ("Checking destination compression: " << dstAddr );
 
-      Ipv6Address myDstAddr = Ipv6Address::MakeAutoconfiguredLinkLocalAddress (dst);
-      NS_LOG_LOGIC ("Checking destination compression: " << myDstAddr << " - " << dstAddr );
+          uint8_t serializedDstAddress[16];
+          dstAddr.Serialize (serializedDstAddress);
 
-      if ( !iphcHeader.GetM () )
-      // Unicast address
-        {
-          if ( myDstAddr == dstAddr )
-            {
-              iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_0);
-            }
-          else if (memcmp (addressBuf, unicastAddrCheckerBuf, 14) == 0)
-            {
-              iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_16);
-            }
-          else if ( dstAddr.IsLinkLocal () )
+          if ( !iphcHeader.GetM () )
             {
-              iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_64);
-            }
-          else
-            {
-              iphcHeader.SetDam (SixLowPanIphc::HC_INLINE);
-            }
-        }
-      else
-        {
-          // Multicast address
-          uint8_t multicastAddrCheckerBuf[16];
-          Ipv6Address multicastCheckAddress = Ipv6Address ("ff02::1");
-          multicastCheckAddress.GetBytes (multicastAddrCheckerBuf);
+              // Unicast address
 
-          // The address takes the form ff02::00XX.
-          if ( memcmp (addressBuf, multicastAddrCheckerBuf, 15) == 0 )
-            {
-              iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_0);
-            }
-          // The address takes the form ffXX::00XX:XXXX.
-          //                            ffXX:0000:0000:0000:0000:0000:00XX:XXXX.
-          else if ( (addressBuf[0] == multicastAddrCheckerBuf[0])
-                    && (memcmp (addressBuf + 2, multicastAddrCheckerBuf + 2, 11) == 0) )
-            {
-              iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_16);
-            }
-          // The address takes the form ffXX::00XX:XXXX:XXXX.
-          //                            ffXX:0000:0000:0000:0000:00XX:XXXX:XXXX.
-          else if ( (addressBuf[0] == multicastAddrCheckerBuf[0])
-                    && (memcmp (addressBuf + 2, multicastAddrCheckerBuf + 2, 9) == 0) )
-            {
-              iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_64);
+              uint8_t dstContextId;
+              if ( FindUnicastCompressionContext (dstAddr, dstContextId) )
+                {
+                  // We can do stateful compression.
+                  NS_LOG_LOGIC ("Checking stateful destination compression: " << dstAddr );
+
+                  iphcHeader.SetDac (true);
+                  if (dstContextId != 0)
+                    {
+                      // the default context is zero, no need to explicit it if it's zero
+                      iphcHeader.SetDstContextId (dstContextId);
+                      iphcHeader.SetCid (true);
+                    }
+
+                  // Note that a context might include parts of the EUI-64 (i.e., be as long as 128 bits).
+                  if (Ipv6Address::MakeAutoconfiguredAddress (dst, m_contextTable[dstContextId].contextPrefix) == dstAddr)
+                    {
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_0);
+                    }
+                  else
+                    {
+                      Ipv6Address cleanedAddr = CleanPrefix (dstAddr, m_contextTable[dstContextId].contextPrefix);
+
+                      uint8_t serializedCleanedAddress[16];
+                      cleanedAddr.Serialize (serializedCleanedAddress);
+
+                      if ( serializedCleanedAddress[8] == 0x00 && serializedCleanedAddress[9] == 0x00 &&
+                          serializedCleanedAddress[10] == 0x00 && serializedCleanedAddress[11] == 0xff &&
+                          serializedCleanedAddress[12] == 0xfe && serializedCleanedAddress[13] == 0x00 )
+                        {
+                          iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_16);
+                          iphcHeader.SetDstInlinePart (serializedCleanedAddress+14, 2);
+                        }
+                      else
+                        {
+                          iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_64);
+                          iphcHeader.SetDstInlinePart (serializedCleanedAddress+8, 8);
+                        }
+                    }
+                }
+              else
+                {
+                  NS_LOG_LOGIC ("Checking stateless destination compression: " << dstAddr );
+
+                  if ( dstAddr == Ipv6Address::MakeAutoconfiguredLinkLocalAddress (dst) )
+                    {
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_0);
+                    }
+                  else if (memcmp (addressBuf, unicastAddrCheckerBuf, 14) == 0)
+                    {
+                      iphcHeader.SetDstInlinePart (serializedDstAddress+14, 2);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_16);
+                    }
+                  else if ( dstAddr.IsLinkLocal () )
+                    {
+                      iphcHeader.SetDstInlinePart (serializedDstAddress+8, 8);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_64);
+                    }
+                  else
+                    {
+                      iphcHeader.SetDstInlinePart (serializedDstAddress, 16);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_INLINE);
+                    }
+                }
             }
           else
             {
-              iphcHeader.SetDam (SixLowPanIphc::HC_INLINE);
+              // Multicast address
+
+              uint8_t dstContextId;
+              if ( FindMulticastCompressionContext (dstAddr, dstContextId) )
+                {
+                  // Stateful compression (only one possible case)
+
+                  // ffXX:XXLL:PPPP:PPPP:PPPP:PPPP:XXXX:XXXX
+                  uint8_t dstInlinePart[6] = {};
+                  dstInlinePart[0] = serializedDstAddress[1];
+                  dstInlinePart[1] = serializedDstAddress[2];
+                  dstInlinePart[2] = serializedDstAddress[12];
+                  dstInlinePart[3] = serializedDstAddress[13];
+                  dstInlinePart[4] = serializedDstAddress[14];
+                  dstInlinePart[5] = serializedDstAddress[15];
+
+                  iphcHeader.SetDac (true);
+                  if (dstContextId != 0)
+                    {
+                      // the default context is zero, no need to explicit it if it's zero
+                      iphcHeader.SetDstContextId (dstContextId);
+                      iphcHeader.SetCid (true);
+                    }
+                  iphcHeader.SetDstInlinePart (dstInlinePart, 6);
+                  iphcHeader.SetDam (SixLowPanIphc::HC_INLINE);
+                }
+              else
+                {
+                  // Stateless compression
+
+                  uint8_t multicastAddrCheckerBuf[16];
+                  Ipv6Address multicastCheckAddress = Ipv6Address ("ff02::1");
+                  multicastCheckAddress.GetBytes (multicastAddrCheckerBuf);
+
+                  // The address takes the form ff02::00XX.
+                  if ( memcmp (addressBuf, multicastAddrCheckerBuf, 15) == 0 )
+                    {
+                      iphcHeader.SetDstInlinePart (serializedDstAddress+15, 1);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_0);
+                    }
+                  // The address takes the form ffXX::00XX:XXXX.
+                  //                            ffXX:0000:0000:0000:0000:0000:00XX:XXXX.
+                  else if ( (addressBuf[0] == multicastAddrCheckerBuf[0])
+                      && (memcmp (addressBuf + 2, multicastAddrCheckerBuf + 2, 11) == 0) )
+                    {
+                      uint8_t dstInlinePart[4] = {};
+                      memcpy (dstInlinePart, serializedDstAddress+1, 1);
+                      memcpy (dstInlinePart+1, serializedDstAddress+13, 3);
+                      iphcHeader.SetDstInlinePart (dstInlinePart, 4);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_16);
+                    }
+                  // The address takes the form ffXX::00XX:XXXX:XXXX.
+                  //                            ffXX:0000:0000:0000:0000:00XX:XXXX:XXXX.
+                  else if ( (addressBuf[0] == multicastAddrCheckerBuf[0])
+                      && (memcmp (addressBuf + 2, multicastAddrCheckerBuf + 2, 9) == 0) )
+                    {
+                      uint8_t dstInlinePart[6] = {};
+                      memcpy (dstInlinePart, serializedDstAddress+1, 1);
+                      memcpy (dstInlinePart+1, serializedDstAddress+11, 5);
+                      iphcHeader.SetDstInlinePart (dstInlinePart, 6);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_COMPR_64);
+                    }
+                  else
+                    {
+                      iphcHeader.SetDstInlinePart (serializedDstAddress, 16);
+                      iphcHeader.SetDam (SixLowPanIphc::HC_INLINE);
+                    }
+                }
             }
         }
 
@@ -1148,7 +1303,6 @@
 
       return size;
     }
-
   return 0;
 }
 
@@ -1173,7 +1327,7 @@
   return ret;
 }
 
-void
+bool
 SixLowPanNetDevice::DecompressLowPanIphc (Ptr<Packet> packet, Address const &src, Address const &dst)
 {
   NS_LOG_FUNCTION (this << *packet << src << dst);
@@ -1191,29 +1345,99 @@
   // Source address
   if ( encoding.GetSac () )
     {
+      // Source address compression uses stateful, context-based compression.
       if ( encoding.GetSam () == SixLowPanIphc::HC_INLINE )
         {
           ipHeader.SetSourceAddress ( Ipv6Address::GetAny () );
         }
       else
         {
-          NS_ABORT_MSG ("SAC option not yet implemented");
+          uint8_t contextId = encoding.GetSrcContextId ();
+          if (m_contextTable.find (contextId) == m_contextTable.end ())
+            {
+              NS_LOG_LOGIC ("Unknown Source compression context (" << +contextId << "), dropping packet");
+              return true;
+            }
+          if (m_contextTable[contextId].validLifetime < Simulator::Now ())
+            {
+              NS_LOG_LOGIC ("Expired Source compression context (" << +contextId << "), dropping packet");
+              return true;
+           }
+
+          uint8_t contexPrefix[16];
+          m_contextTable[contextId].contextPrefix.GetBytes(contexPrefix);
+          uint8_t contextLength = m_contextTable[contextId].contextPrefix.GetPrefixLength ();
+
+          uint8_t srcAddress[16] = { };
+          if ( encoding.GetSam () == SixLowPanIphc::HC_COMPR_64 )
+            {
+              memcpy (srcAddress +8, encoding.GetSrcInlinePart (), 8);
+            }
+          else if ( encoding.GetSam () == SixLowPanIphc::HC_COMPR_16 )
+            {
+              srcAddress[11] = 0xff;
+              srcAddress[12] = 0xfe;
+              memcpy (srcAddress +14, encoding.GetSrcInlinePart (), 2);
+            }
+          else // SixLowPanIphc::HC_COMPR_0
+            {
+              Ipv6Address::MakeAutoconfiguredLinkLocalAddress (src).GetBytes (srcAddress);
+            }
+
+          uint8_t bytesToCopy = contextLength / 8;
+          uint8_t bitsToCopy = contextLength % 8;
+
+          // Do not combine the prefix - we want to override the bytes.
+          for (uint8_t i=0; i<bytesToCopy; i++)
+            {
+              srcAddress[i] = contexPrefix[i];
+            }
+          if (bitsToCopy)
+            {
+              uint8_t addressBitMask = (1<<(8-bitsToCopy))-1;
+              uint8_t prefixBitMask = ~addressBitMask;
+              srcAddress[bytesToCopy] = (contexPrefix[bytesToCopy] & prefixBitMask) | (srcAddress[bytesToCopy] & addressBitMask);
+            }
+          ipHeader.SetSourceAddress ( Ipv6Address::Deserialize (srcAddress) );
         }
     }
   else
     {
-      if ( encoding.GetSam () == SixLowPanIphc::HC_COMPR_0 )
+      // Source address compression uses stateless compression.
+
+      if ( encoding.GetSam () == SixLowPanIphc::HC_INLINE )
         {
-          ipHeader.SetSourceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (src));
+          uint8_t srcAddress[16] = { };
+          memcpy (srcAddress, encoding.GetSrcInlinePart (), 16);
+          ipHeader.SetSourceAddress ( Ipv6Address::Deserialize (srcAddress) );
+        }
+      else if ( encoding.GetSam () == SixLowPanIphc::HC_COMPR_64 )
+        {
+          uint8_t srcAddress[16] = { };
+          memcpy (srcAddress +8, encoding.GetSrcInlinePart (), 8);
+          srcAddress[0] = 0xfe;
+          srcAddress[1] = 0x80;
+          ipHeader.SetSourceAddress ( Ipv6Address::Deserialize (srcAddress) );
+        }
+      else if ( encoding.GetSam () == SixLowPanIphc::HC_COMPR_16 )
+        {
+          uint8_t srcAddress[16] = { };
+          memcpy (srcAddress +14, encoding.GetSrcInlinePart (), 2);
+          srcAddress[0] = 0xfe;
+          srcAddress[1] = 0x80;
+          srcAddress[11] = 0xff;
+          srcAddress[12] = 0xfe;
+          ipHeader.SetSourceAddress ( Ipv6Address::Deserialize (srcAddress) );
         }
-      else
+      else // SixLowPanIphc::HC_COMPR_0
         {
-          ipHeader.SetSourceAddress ( encoding.GetSrcAddress () );
+          ipHeader.SetSourceAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (src));
         }
     }
   // Destination address
   if ( encoding.GetDac () )
     {
+      // Destination address compression uses stateful, context-based compression.
       if ((encoding.GetDam () == SixLowPanIphc::HC_INLINE  && !encoding.GetM ())
           || (encoding.GetDam () == SixLowPanIphc::HC_COMPR_64  && encoding.GetM ())
           || (encoding.GetDam () == SixLowPanIphc::HC_COMPR_16  && encoding.GetM ())
@@ -1221,20 +1445,139 @@
         {
           NS_ABORT_MSG ("Reserved code found");
         }
+
+      uint8_t contextId = encoding.GetDstContextId ();
+      if (m_contextTable.find (contextId) == m_contextTable.end ())
+        {
+          NS_LOG_LOGIC ("Unknown Destination compression context (" << +contextId << "), dropping packet");
+          return true;
+        }
+      if (m_contextTable[contextId].validLifetime < Simulator::Now ())
+        {
+          NS_LOG_LOGIC ("Expired Destination compression context (" << +contextId << "), dropping packet");
+          return true;
+       }
+
+      uint8_t contexPrefix[16];
+      m_contextTable[contextId].contextPrefix.GetBytes(contexPrefix);
+      uint8_t contextLength = m_contextTable[contextId].contextPrefix.GetPrefixLength ();
+
+      if (encoding.GetM () == false)
+        {
+          // unicast
+          uint8_t dstAddress[16] = { };
+          if ( encoding.GetDam () == SixLowPanIphc::HC_COMPR_64 )
+            {
+              memcpy (dstAddress +8, encoding.GetDstInlinePart (), 8);
+            }
+          else if ( encoding.GetDam () == SixLowPanIphc::HC_COMPR_16 )
+            {
+              dstAddress[11] = 0xff;
+              dstAddress[12] = 0xfe;
+              memcpy (dstAddress +14, encoding.GetDstInlinePart (), 2);
+            }
+          else // SixLowPanIphc::HC_COMPR_0
+            {
+              Ipv6Address::MakeAutoconfiguredLinkLocalAddress (dst).GetBytes (dstAddress);
+            }
+
+          uint8_t bytesToCopy = m_contextTable[contextId].contextPrefix.GetPrefixLength () / 8;
+          uint8_t bitsToCopy = contextLength % 8;
+
+          // Do not combine the prefix - we want to override the bytes.
+          for (uint8_t i=0; i<bytesToCopy; i++)
+            {
+              dstAddress[i] = contexPrefix[i];
+            }
+          if (bitsToCopy)
+            {
+              uint8_t addressBitMask = (1<<(8-bitsToCopy))-1;
+              uint8_t prefixBitMask = ~addressBitMask;
+              dstAddress[bytesToCopy] = (contexPrefix[bytesToCopy] & prefixBitMask) | (dstAddress[bytesToCopy] & addressBitMask);
+            }
+          ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+        }
       else
         {
-          NS_ABORT_MSG ("DAC option not yet implemented");
+          // multicast
+          // Just one possibility: ffXX:XXLL:PPPP:PPPP:PPPP:PPPP:XXXX:XXXX
+          uint8_t dstAddress[16] = { };
+          dstAddress[0] = 0xff;
+          memcpy (dstAddress +1, encoding.GetDstInlinePart (), 2);
+          dstAddress[3] = contextLength;
+          memcpy (dstAddress +4, contexPrefix, 8);
+          memcpy (dstAddress +12, encoding.GetDstInlinePart ()+2, 4);
+          ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
         }
     }
   else
     {
-      if ( !encoding.GetM () && encoding.GetDam () == SixLowPanIphc::HC_COMPR_0 )
-        {
-          ipHeader.SetDestinationAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (dst));
-        }
-      else
+      // Destination address compression uses stateless compression.
+      if (encoding.GetM () == false)
         {
-          ipHeader.SetDestinationAddress ( encoding.GetDstAddress () );
+          // unicast
+          if ( encoding.GetDam () == SixLowPanIphc::HC_INLINE )
+             {
+               uint8_t dstAddress[16] = { };
+               memcpy (dstAddress, encoding.GetDstInlinePart (), 16);
+               ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+             }
+          else if ( encoding.GetDam () == SixLowPanIphc::HC_COMPR_64 )
+            {
+              uint8_t dstAddress[16] = { };
+              memcpy (dstAddress +8, encoding.GetDstInlinePart (), 8);
+              dstAddress[0] = 0xfe;
+              dstAddress[1] = 0x80;
+              ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+            }
+          else if ( encoding.GetDam () == SixLowPanIphc::HC_COMPR_16 )
+            {
+              uint8_t dstAddress[16] = { };
+              memcpy (dstAddress +14, encoding.GetDstInlinePart (), 2);
+              dstAddress[0] = 0xfe;
+              dstAddress[1] = 0x80;
+              dstAddress[11] = 0xff;
+              dstAddress[12] = 0xfe;
+              ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+            }
+          else // SixLowPanIphc::HC_COMPR_0
+            {
+              ipHeader.SetDestinationAddress (Ipv6Address::MakeAutoconfiguredLinkLocalAddress (dst));
+            }
+         }
+      else
+        {
+          // multicast
+          if ( encoding.GetDam () == SixLowPanIphc::HC_INLINE )
+            {
+              uint8_t dstAddress[16] = { };
+              memcpy (dstAddress, encoding.GetDstInlinePart (), 16);
+              ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+            }
+          else if ( encoding.GetDam () == SixLowPanIphc::HC_COMPR_64 )
+            {
+              uint8_t dstAddress[16] = { };
+              dstAddress[0] = 0xff;
+              memcpy (dstAddress +1, encoding.GetDstInlinePart (), 1);
+              memcpy (dstAddress +11, encoding.GetDstInlinePart ()+1, 5);
+              ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+            }
+          else if ( encoding.GetDam () == SixLowPanIphc::HC_COMPR_16 )
+            {
+              uint8_t dstAddress[16] = { };
+              dstAddress[0] = 0xff;
+              memcpy (dstAddress +1, encoding.GetDstInlinePart (), 1);
+              memcpy (dstAddress +13, encoding.GetDstInlinePart ()+1, 3);
+              ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+            }
+          else // SixLowPanIphc::HC_COMPR_0
+            {
+              uint8_t dstAddress[16] = { };
+              dstAddress[0] = 0xff;
+              dstAddress[1] = 0x02;
+              memcpy (dstAddress+15, encoding.GetDstInlinePart (), 1);
+              ipHeader.SetDestinationAddress ( Ipv6Address::Deserialize (dstAddress) );
+            }
         }
     }
 
@@ -1282,7 +1625,15 @@
         }
       else
         {
-          ipHeader.SetNextHeader (DecompressLowPanNhc (packet, src, dst, ipHeader.GetSourceAddress (), ipHeader.GetDestinationAddress ()));
+          std::pair <uint8_t, bool> retval = DecompressLowPanNhc (packet, src, dst, ipHeader.GetSourceAddress (), ipHeader.GetDestinationAddress ());
+          if ( retval.second == true )
+            {
+              return true;
+            }
+          else
+            {
+              ipHeader.SetNextHeader (retval.first);
+            }
         }
     }
   else
@@ -1294,8 +1645,9 @@
 
   packet->AddHeader (ipHeader);
 
-  NS_LOG_DEBUG ( "Rebuilt packet: " << *packet << " Size " << packet->GetSize () );
+  NS_LOG_DEBUG ( "Rebuilt packet:  " << *packet << " Size " << packet->GetSize () );
 
+  return false;
 }
 
 uint32_t
@@ -1557,7 +1909,7 @@
   return size;
 }
 
-uint8_t
+std::pair <uint8_t, bool>
 SixLowPanNetDevice::DecompressLowPanNhc (Ptr<Packet> packet, Address const &src, Address const &dst, Ipv6Address srcAddress, Ipv6Address dstAddress)
 {
   NS_LOG_FUNCTION (this << *packet);
@@ -1602,7 +1954,7 @@
             }
           else
             {
-              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress);
+              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress).first;
             }
         }
       else
@@ -1654,7 +2006,7 @@
             }
           else
             {
-              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress);
+              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress).first;
             }
         }
       else
@@ -1686,7 +2038,7 @@
             }
           else
             {
-              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress);
+              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress).first;
             }
         }
       else
@@ -1720,7 +2072,7 @@
             }
           else
             {
-              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress);
+              blobData [0] = DecompressLowPanNhc (packet, src, dst, srcAddress, dstAddress).first;
             }
         }
       else
